package be.jeffcheasey88.peeratcode.parser.java.operations;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import be.jeffcheasey88.peeratcode.parser.java.CleanerPool;
import be.jeffcheasey88.peeratcode.parser.java.JavaElement;

public class ReturnOperation extends JavaElement{

	private static Pattern PATTERN = Pattern.compile("^(\\s*return\\s*([^;]*);).*$");
	
	private static OperationFactory FACTORY = OperationFactory.getFactory();
	
	private String toChange;
	private JavaElement value;
	
	public ReturnOperation(){}
	
	@Override
	public int parse(String content, CleanerPool global, CleanerPool local) throws Exception{
		Matcher matcher = PATTERN.matcher(content);
		matcher.matches();
		
		//To update for native obj
		this.toChange = matcher.group(2);
		JavaElement operation = FACTORY.buildOperation(toChange+";");
		if(operation != null){
			System.out.println(operation.getClass().getSimpleName());
			value = operation;
			value.parse(toChange+";", global, local);
		}
		
		return matcher.group(1).length();
	}

	@Override
	public void show(int tab){
		String start = "";
		for(int i = 0; i < tab; i++) start+="\t";
		if(value != null){
			System.out.println("return");
			value.show(tab+1);
			System.out.println(";");
			return;
		}
		System.out.println(start+"return "+toChange+";");
	}

}
